#!/bin/sh

SCRIPTS_PATH=$('pwd')
MCSV_PATH="$('pwd')/../"
DEVOPS_VERSION="2"
DEVOPS_REVISION="19"
DEVOPS_BUILD="0"
PACKAGE_VERSION="$DEVOPS_VERSION.$DEVOPS_REVISION.$DEVOPS_BUILD"
REVISION_DATE=$(date +%s)

echo 'Front and Back Steps -----------------------------------------------------'
cd $MCSV_PATH/backend
$SCRIPTS_PATH/back_step.sh $DEVOPS_VERSION $DEVOPS_REVISION $DEVOPS_BUILD

cd $MCSV_PATH/mobile
$SCRIPTS_PATH/front_step.sh

echo 'Run Grunt Tasks For Production -------------------------------------------'
grunt buildEnvironment:production

echo 'Update Package Version ---------------------------------------------------'
cd $MCSV_PATH/backend/config
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "parameters.xml"
cat ./parameters.xml

cd $MCSV_PATH/
$SCRIPTS_PATH/replace.sh "0.0.0" $PACKAGE_VERSION "productInfo.json"
cat ./productInfo.json

cd $MCSV_PATH/version
$SCRIPTS_PATH/replace.sh "0" 2 "version.json"
$SCRIPTS_PATH/replace.sh "8" 19 "version.json"
$SCRIPTS_PATH/replace.sh "6" 0 "version.json"
$SCRIPTS_PATH/replace.sh "1422548005582" $REVISION_DATE "version.json"
cat ./version.json

echo 'Remove development dependencies ------------------------------------------'
rm -f $MCSV_PATH/README.md

echo 'Remove all .git folders --------------------------------------------------'
cd $MCSV_PATH/

find . -name .git -exec rm -rf {} +
find . -name "*.template" -type f|xargs rm -f
find . -name "*.gitignore" -type f|xargs rm -f
find . -name "README.md" -exec rm -r {} +
find . -name "README" -exec rm -r {} +
